package top.liangwy.read_statistics.controller;

import org.apache.ibatis.session.SqlSession;
//import org.joda.time.DateTime;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import top.liangwy.read_statistics.common.BaseController;
import top.liangwy.read_statistics.dao.DeptMapper;
import top.liangwy.read_statistics.dao.ScanMapper;
import top.liangwy.read_statistics.dao.UserMapper;
import top.liangwy.read_statistics.pojo.Dept;
import top.liangwy.read_statistics.pojo.User;
import top.liangwy.read_statistics.pojo.Result.UserScan;
import top.liangwy.read_statistics.utils.MybatisUtils;
import java.time.LocalDateTime;
import java.util.*;

/**
 * @author lwy
 * @ 微信 在看
 */
@Controller
@RequestMapping("/scan")
public class ScanController extends BaseController {

    @GetMapping("/today")
    public String home(Model model) {
        SqlSession sqlSession = MybatisUtils.getSqlSession();
        UserMapper userMapper = sqlSession.getMapper(UserMapper.class);
        DeptMapper deptMapper = sqlSession.getMapper(DeptMapper.class);
        ScanMapper scanMapper = sqlSession.getMapper(ScanMapper.class);

        int status = 0;

        LocalDateTime now = LocalDateTime.now();
        int year = now.getYear();
        int month = now.getMonthValue();
        int day = now.getDayOfMonth();
        int hour = now.getHour();
        int minute = now.getMinute();
        int second = now.getSecond();
        String userScanString = scanMapper.getUserScanList();
        System.out.println(year + "年" + month + "月" + day + "日 " + hour + "：" + minute + "：" + second +
                " 点击在看的人员是：" + userScanString);
        if (null == userScanString) {
            status = 1;
        } else {
            String newUserScanString = userScanString.replace(" ", "");
            String[] a = newUserScanString.split(",");
            model.addAttribute("date", year + "年" + month + "月" + day + "日");

            // 获取所有部门名称
            List<Dept> deptList = deptMapper.getAllDeptName();

            // 创建有序键值对储存总的数据
            Map<String, List<UserScan>> map = new LinkedHashMap<String, List<UserScan>>(deptList.size());

            for (int i = 0; i < deptList.size(); i++) {

                // 获取指定部门的人员信息
                List<User> arrayList = userMapper.getUserByDeptId(deptList.get(i).getDeptId());

                List<UserScan> userList = new ArrayList<>();
                for (int j = 0; j < arrayList.size(); j++) {
                    UserScan us = new UserScan();
                    us.setUserName(arrayList.get(j).getUserName());
                    for (int k = 0; k < a.length; k++) {
                        if (us.getUserName().equals(a[k])) {
                            us.setScanStatus("已完成");
                        }
                    }
                    userList.add(us);
                }
                map.put(deptList.get(i).getDeptName(), userList);
            }
            sqlSession.close();
            model.addAttribute("list", map);
        }
        sqlSession.close();
        model.addAttribute("status", status);
        return "/scan/today";
    }

    @RequestMapping("/insert")
    public String edit(String userScanList, Model model) {
        System.out.println("123insert");
        SqlSession sqlSession = MybatisUtils.getSqlSession();
        ScanMapper scanMapper = sqlSession.getMapper(ScanMapper.class);

        String newUserScanList = ScanFree + userScanList;
        if (userScanList != null) {
            int i = scanMapper.setUserScanList(newUserScanList);
            if (i == 1) {
                sqlSession.commit();
                sqlSession.close();
                model.addAttribute("info", "success");
            }
        }
        sqlSession.close();
        return "/scan/insert";
    }
}
