package top.liangwy.read_statistics.controller;

import org.apache.ibatis.session.SqlSession;
//import org.joda.time.DateTime;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import top.liangwy.read_statistics.common.BaseController;
import top.liangwy.read_statistics.dao.DeptMapper;
import top.liangwy.read_statistics.dao.UserMapper;
import top.liangwy.read_statistics.dao.WbMapper;
import top.liangwy.read_statistics.pojo.Dept;
import top.liangwy.read_statistics.pojo.User;
import top.liangwy.read_statistics.pojo.Result.UserScan;
import top.liangwy.read_statistics.utils.MybatisUtils;

import java.time.LocalDateTime;
import java.util.*;

/**
 * @author lwy
 * @ 微博
 */
@Controller
@RequestMapping("/wb")
public class WbController extends BaseController {

    @GetMapping("/today")
    public String today(Model model) {

        int status = 0;

        SqlSession sqlSession = MybatisUtils.getSqlSession();
        UserMapper userMapper = sqlSession.getMapper(UserMapper.class);
        DeptMapper deptMapper = sqlSession.getMapper((DeptMapper.class));
        WbMapper wbMapper = sqlSession.getMapper(WbMapper.class);

        LocalDateTime now = LocalDateTime.now();
        int year = now.getYear();
        int month = now.getMonthValue();
        int day = now.getDayOfMonth();
        int hour = now.getHour();
        int minute = now.getMinute();
        int second = now.getSecond();
        String wbUserScanString = wbMapper.getWbUserScanList();
        if (null == wbUserScanString) {
            status = 1;
        } else {
            System.out
                    .println(year + "年" + month + "月" + day + "日 " + hour + "：" + minute + "：" + second +
                            " 微博点赞评论人员是：" + wbUserScanString);
            String newWbUserScanString = WbFree + wbUserScanString.replace(" ", "");
            System.out.println(newWbUserScanString);
            String[] a = newWbUserScanString.split(",");
            model.addAttribute("date", year + "年" + month + "月" + day + "日");

            // 获取所有部门名称
            List<Dept> deptList = deptMapper.getAllDeptName();

            // 创建有序键值对储存总的数据
            Map<String, List<UserScan>> map = new LinkedHashMap<String, List<UserScan>>(deptList.size());

            for (int i = 1; i < deptList.size(); i++) {

                // 获取指定部门的人员信息
                List<User> arrayList = userMapper.getUserByDeptId(deptList.get(i).getDeptId());
                List<UserScan> userList = new ArrayList<>();
                for (int j = 0; j < arrayList.size(); j++) {

                    if (i == 3) {
                        System.out.println(arrayList.get(j).getUserName());
                        System.out.println(arrayList.get(j).getWbNickName());
                    }

                    UserScan us = new UserScan();
                    us.setUserName(arrayList.get(j).getUserName());
                    us.setKsNickName(arrayList.get(j).getWbNickName());
                    for (int k = 0; k < a.length; k++) {
                        if (null == us.getKsNickName()) {
                            us.setKsNickName("");
                        }
                        if (us.getKsNickName().equals(a[k])) {
                            us.setScanStatus("已完成");
                        }
                    }
                    userList.add(us);
                }
                map.put(deptList.get(i).getDeptName(), userList);
            }
            model.addAttribute("list", map);
        }
        sqlSession.close();
        model.addAttribute("status", status);
        return "/wb/today";
    }

    @RequestMapping("/insert")
    public String edit(String wbUserScanList, Model model) {

        SqlSession sqlSession = MybatisUtils.getSqlSession();
        WbMapper wbMapper = sqlSession.getMapper(WbMapper.class);

        String newWbUserScanList = ScanFree + wbUserScanList;
        System.out.println(wbUserScanList);
        if (wbUserScanList != null) {
            int i = wbMapper.setWbUserScanList(newWbUserScanList);
            if (i == 1) {
                sqlSession.commit();
                sqlSession.close();
                model.addAttribute("info", "success");
            }
        }
        sqlSession.close();
        return "/wb/insert";
    }
}
